Index: Commands2.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/Commands2.cpp,v
retrieving revision 1.119
diff -u -p -b -r1.119 Commands2.cpp
--- Commands2.cpp	23 Jan 2005 01:34:53 -0000	1.119
+++ Commands2.cpp	10 Apr 2005 22:43:18 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: Commands2.cpp,v 1.119 2005/01/23 01:34:53 klas Exp $
+// $Id: Commands2.cpp,v 1.156 2005/04/10 21:57:36 jockelundin Exp $
 //
 // Usage: Ftp commands and data transfer functions
 //
@@ -7,89 +7,116 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#define __COMMANDS2_CPP__
-#define _STREAM_COMPAT
-#define __NETINCLS__
+#define COMMANDS2_CPP
+#define NETINCLS
 #include "Commands.h"
 
-bool Commands::quit(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::quit)
 {
-  Commands::ftp_send(user, "221 Goodbye. You transfered a total of " + util.itos(user->total_transfered) + " bytes.");
+  *user << "221 Goodbye. You transfered a total of "
+    << user->total_transfered() << " bytes." << "\r\n";
 
-  sem_wait(&user->user_lock);
-  user->logged_in = LOGGED_OUT;
-  sem_post(&user->user_lock);
-  close(user->socket_id);
+  user->settings(FAILURE, B_SET);
   return(true);
 }
 
-bool Commands::user(User *user, string user_name, unsigned int flag)
+BABY_COM(Commands::user)
 {
-  if(user->logged_in == LOGGED_IN)
+  string message;
+  bool ret = true, bad = false;
+  if(user->logged_in() == LOGGED_IN)
   {
-    Commands::ftp_send(user, "503 You are already logged in!");
-    return(false);
+    message = "503 You are already logged in!";
+    ret = false;
   }
+  else
+  {
+    int current_connections = 0;
+    for(vector<User*>::iterator user_it = user_list.begin();
+        user_it != user_list.end(); user_it++)
+      if((*user_it)->user_name() == argument)
+        current_connections++;
+
+    user->user_name(argument);
+    user->logged_in(USER_SUPPLIED);
 
+    if(config->get_user(argument).noftp == true)
+    {
+      message = "421 Sorry, you are not allowed to use ftp. disconnecting.";
+      bad = true;
+    }
+    else if(current_connections >= config->get_user(argument).user_limit){
+      message =
+        "421 You have reached your maximum number of control connections.";
+      bad = true;
+    }
 #ifdef USE_TLS
-  string failure;
-  if(config->get_user(user_name).encryption == FORCE &&
-      !user->settings.test(TLS_ENABLED))
-    failure = "421 You muse enable encryption before logging in, disconnecting.";
-  else if(config->get_user(user_name).encryption == DENY &&
-      user->settings.test(TLS_ENABLED))
-    failure =  "421 Sorry, you are not allowed to connect with encryption enabled, disconnecting.";
-
-  if(!failure.empty())
-  {
-    Commands::ftp_send(user, failure);
-    sem_wait(&user->user_lock);
-    user->logged_in = LOGGED_OUT;
-    sem_post(&user->user_lock);
-    return(false);
+    else if(config->get_user(argument).encryption == DENY &&
+        user->settings(TLS_ENABLED))
+    {
+      message =  "421 Sorry, you are not allowed to connect with"
+        "encryption enabled, disconnecting.";
+      bad = true;
+    }
+    else if(user->settings(TLS_ENABLED) && user->verify_cert())
+    {
+      message = "230 Logged in as " + argument + ".";
+      user->login();
+    }
+    else if(config->get_user(argument).encryption == FORCE_CERT)
+    {
+      message = "421 You must supply a valid certificate to login.";
+      bad = true;
+    }
+    else if(config->get_user(argument).encryption == FORCE &&
+        !user->settings(TLS_ENABLED))
+    {
+      message =
+        "421 You must enable encryption before logging in, disconnecting.";
+      bad = true;
   }
 #endif // USE_TLS
-  int current_connections = 0;
-  for(vector<User*>::iterator user_it = user_list.begin();
-      user_it != user_list.end(); user_it++){
-    if((*user_it)->user_name == user_name)
-      current_connections++;
+    else
+      message = "331 Password required for " + argument + ".";
   }
-  if(current_connections >= config->get_user(user_name).user_limit){
-     Commands::ftp_send(user, "421 You have reached your maximum number of control connections.");
-     return(false);
+  *user << message << "\r\n";
+  if(bad)
+  {
+    user->settings(FAILURE, B_SET);
+    ret = false;
   }
-
-  sem_wait(&user->user_lock);
-  user->user_name = user_name;
-  user->logged_in = USER_SUPPLIED;
-  sem_post(&user->user_lock);
-  Commands::ftp_send(user, "331 Password required for " + user_name + ".");
-
-  return(true);
+  return(ret);
 }
 
-bool Commands::abor(User *user, string argument, unsigned int flag) // FIXME please?
+BABY_COM(Commands::abor)
 {
-  ftp_send(user, "502 Command not implemented.");
+  string message = "226 ";
+  if(user->data_vec.empty())
+    message += "No Data Connections to cancel";
+  else
+  {
+    for(vector<class Data*>::iterator data_it = user->data_vec.begin();
+        data_it != user->data_vec.end(); data_it++)
+      if(*data_it)
+        pthread_cancel((*data_it)->thread_id());
+    message += "All Data Connections Successfully closed.";
+  }
+  *user << message << ".\r\n";
   return(true);
 }
 
-bool Commands::pass(User *user, string passwd, unsigned int flag)
+BABY_COM(Commands::pass)
 {
-  char pwdata[PWBUF_SIZE];
-  struct passwd pwd, *pwd_ptr;
-
   // before everything else, lets check if it is really time for pass...
-  if(user->logged_in != USER_SUPPLIED)
+  if(user->logged_in() != USER_SUPPLIED)
   {
     string message;
-    if(user->logged_in == NOT_LOGGED_IN)
+    if(user->logged_in() == NOT_LOGGED_IN)
       message = "503 Login with 'USER' first.";
-    else if(user->logged_in == LOGGED_IN)
+    else if(user->logged_in() == LOGGED_IN)
       message = "503 You are already logged in!";
 
-    ftp_send(user, message);
+    *user << message << "\r\n";
     return(false);
   }
 
@@ -98,27 +125,30 @@ bool Commands::pass(User *user, string p
   struct pam_data *auth_data = new struct pam_data;
   struct pam_conv pamconv = { &pam_conversate, auth_data };
   int pam_error = 0;
+  pam_handle_t *tmp_pamh = user->pamh();
 
-  auth_data->user_name = user->user_name;
-  auth_data->password = passwd;
+  auth_data->user_name = user->user_name();
+  auth_data->password = argument;
+  argument.clear();
 
   sem_wait(&comm.pam_lock);
-  pam_error = pam_start("babyftpd", user->user_name.c_str(),
-      &pamconv, &user->pamh);
+  pam_error = pam_start("babyftpd", user->user_name().c_str(),
+      &pamconv, &tmp_pamh);
+  user->pamh(tmp_pamh);
 
   if(pam_error == 0)
   {
-    pam_error = pam_authenticate(user->pamh, 0);
+    pam_error = pam_authenticate(user->pamh(), 0);
     if(pam_error == 0)
     {
-      pam_error = pam_acct_mgmt(user->pamh, 0);
+      pam_error = pam_acct_mgmt(user->pamh(), 0);
       if(pam_error == 0)
-        pam_error = pam_setcred(user->pamh, PAM_ESTABLISH_CRED);
+        pam_error = pam_setcred(user->pamh(), PAM_ESTABLISH_CRED);
     }
   }
   if(pam_error != 0)
   {
-    pam_end(user->pamh, pam_error);
+    pam_end(user->pamh(), pam_error);
     sem_post(&pam_lock);
     seteuid(config->general.user); // and back to some other user..
   }
@@ -127,91 +157,85 @@ bool Commands::pass(User *user, string p
 
   if(pam_error == 0)
   {
-    pam_open_session(user->pamh, PAM_SILENT);
-    user->settings.set(PAM_DONE);
+    pam_open_session(user->pamh(), PAM_SILENT);
+    user->settings(PAM_DONE, B_SET);
 
     const char *pam_username;
-    pam_get_item(user->pamh, PAM_USER,
+    pam_get_item(user->pamh(), PAM_USER,
         (reinterpret_cast<const void**>(&pam_username)));
     sem_post(&pam_lock);
-    if(user->user_name != pam_username)
+    if(user->user_name() != pam_username)
     {
-      logging->log_this(4, LOG_INFO, "PAM changed username of " +
-          user->user_name + " to " + pam_username);
-      user->user_name = pam_username;
-    }
-
-    Commands::ftp_send(user, "230 Password accepted, proceeding.");
-    sem_wait(&user->user_lock);
-    user->logged_in = LOGGED_IN;
-    sem_post(&user->user_lock);
-    getpwnam_r(user->user_name.c_str(), &pwd, pwdata, sizeof(pwdata), &pwd_ptr);
-    uid_t uid = pwd.pw_uid;
-    gid_t gid = pwd.pw_gid;
-    sem_wait(&user->user_lock);
-    if(config->get_user(user->user_name).only_home)
-      user->root_dir = pwd.pw_dir;
-    user->current_dir = pwd.pw_dir;
-    sem_post(&user->user_lock);
-    setgid(gid);
-    seteuid(uid); // dropping permissions...
+      logging->log_this(3, LOG_INFO, "PAM changed username of " +
+          user->user_name() + " to " + pam_username);
+      user->user_name(pam_username);
+    }
+
+      *user << "230 Password accepted, proceeding.\r\n";
+    user->login();
     return(true);
   }
-  sem_post(&user->user_lock);
-  ftp_send(user, "530 Login denied.");
+  *user << "530 Login denied.\r\n";
   return(false);
 }
 
-bool Commands::help(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::help)
 {
   string message;
   if(!argument.size())
   {
     int cmd = 0;
     message = "214-The following commands are understood:\r\n ";
-    while(handler.cmd_info[cmd].command != "\n")
+    for(hash_map<const char*, struct command_info, hash<const char*>,
+        Utilities::eqstr>::iterator cmd_it = handler->cmd_info.begin();
+        cmd_it != handler->cmd_info.end(); cmd_it++)
     {
       if(cmd != 0 && cmd % 8 == 0)
         message += "\r\n ";
-      if(handler.cmd_info[cmd].hlp_info.size() != 0)
-        message += handler.cmd_info[cmd].command + "\t";
+      if(!(*(cmd_it)).second.hlp_info.empty())
+      {
+        message += (*(cmd_it)).first;
+        message += '\t';
       cmd++;
     }
-    message += "\r\n214 if you have any trouble please contact the administrator at " + config->general.admin_email + ".";
+    }
+    message +=
+      "\r\n214 if you have any trouble please contact the administrator at "
+      + config->general.admin_email + ".";
   }
   else
   {
     // other help stuff here...
     message  = "214 Syntax: ";
-    transform(argument.begin(), argument.end(), argument.begin(), (int(*)(int))toupper);
-    int cmd = 0;
-    for(; handler.cmd_info[cmd].command != "\n"; cmd++)
-      if(handler.cmd_info[cmd].command == argument && handler.cmd_info[cmd].hlp_info.size() != 0)
-      {
-        message += handler.cmd_info[cmd].command + handler.cmd_info[cmd].hlp_info;
-        break;
-      }
-
-    if(handler.cmd_info[cmd].command == "\n")
+    transform(argument.begin(), argument.end(), argument.begin(),
+        (int(*)(int))toupper);
+    hash_map<const char*, struct command_info, hash<const char*>, Utilities::
+      eqstr>::iterator cmd_it = handler->cmd_info.find(argument.c_str());
+
+    if(cmd_it != handler->cmd_info.end() &&
+        !(*(cmd_it)).second.hlp_info.empty())
+      message += ((*(cmd_it)).first + (*(cmd_it)).second.hlp_info);
+    else
       message = "500 No help available for '" + argument + "'";
   }
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::cwd(User *user, string dir, unsigned int flag)
+BABY_COM(Commands::cwd)
 {
   struct stat stt;
   string message, new_dir;
   DIR *tmp_dir;
 
   if(util.is_set(flag, COM_CDUP))
-    dir = "..";
+    argument = "..";
 
-  if((user->root_dir.size() > 1 && (user->current_dir.size() == user->root_dir.size())) && (dir == ".." || dir == "."))
-    new_dir = user->root_dir;
+  if((user->root_dir().size() > 1 && (user->current_dir().size() ==
+          user->root_dir().size())) && (argument == ".." || argument == "."))
+    new_dir = user->root_dir();
   else
-    new_dir = Commands::parsedir(user, dir);
+    new_dir = this->parsedir(user, argument);
 
 
   lstat(new_dir.c_str(), &stt);
@@ -224,7 +248,7 @@ bool Commands::cwd(User *user, string di
     len = readlink(new_dir.c_str(), real_name, 60);
     real_name[len] = '\0';
 
-    new_dir = Commands::parsedir(user, real_name);
+    new_dir = this->parsedir(user, real_name);
   }
 
   if(!(tmp_dir = opendir(new_dir.c_str())))
@@ -241,72 +265,65 @@ bool Commands::cwd(User *user, string di
     else // COM_CWD
       message = "250 'CWD' command successful.";
 
-    sem_wait(&user->user_lock);
-    user->current_dir = new_dir;
-    sem_post(&user->user_lock);
+    user->current_dir(new_dir);
   }
   closedir(tmp_dir);
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::retr(User *user, string file, unsigned int flag)
+BABY_COM(Commands::retr)
 {
   struct stat stt;
 
-  string file_name = parsedir(user, file);
+  string file_name = parsedir(user, argument);
   stat(file_name.c_str(), &stt);
   if(!S_ISREG(stt.st_mode))
   {
-    ftp_send(user, "550 \"" + file + "\" is not a regular file.");
+    *user << "550 \"" << argument << "\" is not a regular file.\r\n";
     return(false);
   }
 
   int file_id = open(file_name.c_str(), O_RDONLY);
-  if(user->rest_pos > 0)
+  if(user->rest_pos() > 0)
   {
-    lseek(file_id, user->rest_pos, SEEK_SET);
-    sem_wait(&user->user_lock);
-    user->rest_pos = 0;
-    sem_post(&user->user_lock);
+    lseek(file_id, user->rest_pos(), SEEK_SET);
+    user->rest_pos(0);
   }
 
-  ftp_send(user, "150 Opening " + static_cast<string>(user->settings.test(BINARY)?"BINARY":"ASCII") + " mode data connection for \"" + file + "\" (" + util.itos(stt.st_size) + " bytes).");
+  *user << "150 Opening " << (user->settings(BINARY)?"BINARY":"ASCII")
+      << " mode data connection for \"" << argument << "\" ("
+      << util.itos(stt.st_size) << " bytes).\r\n";
 
   class Data *data = new Data(user, file_id, file_name, 1);
-  if(!data->isOpen() || user->data_vec_full())
+  if(!data->settings(DATA_OPEN) || user->data_vec_full())
   {
-    ftp_send(user, "425 Can't open data connection.");
+    *user << "425 Can't open data connection.\r\n";
     delete data;
     return(false);
   }
 
-  sem_wait(&user->user_lock);
-  if(user->rest_pos > 0)
-  {
-    sem_wait(&data->data_lock);
-    data->rest_pos = user->rest_pos;
-    sem_post(&data->data_lock);
-    user->rest_pos = 0;
-  }
-
+  sem_wait(&user->lock);
   user->data_vec.push_back(data);
-  sem_post(&user->user_lock);
-  pthread_create(&data->thread_id, NULL, data_wrapper, static_cast<void*>(data));
-  pthread_detach(data->thread_id);
+  sem_post(&user->lock);
+  pthread_t temp_id;
+  pthread_create(&temp_id, NULL, data_wrapper,
+      static_cast<void*>(data));
   return(true);
 }
 
-bool Commands::stor(User *user, string file, unsigned int flag)
+BABY_COM(Commands::stor)
 {
   int file_id;
 
-  string file_name = parsedir(user, file);
+  string file_name = parsedir(user, argument);
 
   if(util.is_set(flag, COM_STOR))
-    file_id = open(file_name.c_str(), O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
+    file_id = open(file_name.c_str(), O_WRONLY|O_CREAT|O_TRUNC,
+        S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
   else // com_type == COM_APPE
-    file_id = open(file_name.c_str(), O_WRONLY|O_APPEND|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
+    file_id = open(file_name.c_str(), O_WRONLY|O_APPEND|O_TRUNC,
+        S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
 
   if(file_id == -1)
   {
@@ -319,42 +336,34 @@ bool Commands::stor(User *user, string f
       message = "550 Access to " + file_name + " denied.";
     else
       message = "550 File operation failed.";
-    ftp_send(user, message);
+    *user << message << "\r\n";
     return false;
   }
 
-  if(user->rest_pos > 0 && util.is_set(flag, COM_STOR)) // shouldn't try to restart an appending :p
+  // shouldn't try to restart an appending :p
+  if(user->rest_pos() > 0 && util.is_set(flag, COM_STOR))
   {
-    lseek(file_id, user->rest_pos, SEEK_SET);
-    sem_wait(&user->user_lock);
-    user->rest_pos = 0;
-    sem_post(&user->user_lock);
+    lseek(file_id, user->rest_pos(), SEEK_SET);
+    user->rest_pos(0);
   }
 
-  ftp_send(user, "150 Opening " + static_cast<string>(user->settings.test(BINARY)?"BINARY":"ASCII") + " mode data connection for \"" + file + "\".");
+  *user << "150 Opening " << (user->settings(BINARY)?"BINARY":"ASCII")
+      << " mode data connection for \"" << argument << "\".\r\n";
 
   class Data *data = new Data(user, file_id, file_name, 0);
-  if(!data->isOpen() || user->data_vec_full())
+  if(!data->settings(DATA_OPEN) || user->data_vec_full())
   {
-    ftp_send(user, "425 Can't open data connection.");
+    *user << "425 Can't open data connection.\r\n";
     delete data;
     return(false);
   }
 
-  sem_wait(&user->user_lock);
-  if(user->rest_pos > 0 && util.is_set(flag, COM_STOR)) // shouldn't try to restart an appending :p
-  {
-    lseek(file_id, user->rest_pos, SEEK_SET);
-    sem_wait(&data->data_lock);
-    data->rest_pos = user->rest_pos;
-    sem_post(&data->data_lock);
-    user->rest_pos = 0;
-  }
-
+  sem_wait(&user->lock);
   user->data_vec.push_back(data);
-  sem_post(&user->user_lock);
-  pthread_create(&data->thread_id, NULL, data_wrapper, static_cast<void*>(data));
-  pthread_detach(data->thread_id);
+  sem_post(&user->lock);
+  pthread_t temp_id;
+  pthread_create(&temp_id, NULL, data_wrapper,
+      static_cast<void*>(data));
   return(true);
 }
 
@@ -363,56 +372,64 @@ bool Commands::rest(User *user, string a
   char *endptr;
   string message;
 
-  unsigned long fpos = strtoul(argument.c_str(), &endptr, 0);
+  off_t fpos = strtoul(argument.c_str(), &endptr, 0);
   if(!*endptr)
   {
-    sem_wait(&user->user_lock);
-    user->rest_pos = fpos;
-    sem_post(&user->user_lock);
+    user->rest_pos(fpos);
     message = "350 Restarting at " + argument + ". Send STOR or RETR.";
   }
   else
     message = "501 Restart point not in numeric format.";
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::list(User *user, string argument, unsigned int flag)
+BABY_COM(Commands::list)
 {
   struct stat stt;
   string failure;
 
   if(argument.size() == 0)
-    argument = user->current_dir;
+    argument = user->current_dir();
 
   string file = parsedir(user, argument);
-  int stat_err = lstat(file.c_str(), &stt);
 
-  if(stat_err == -1 && ((util.is_set(flag, COM_LONG) || util.is_set(flag, COM_MLSD)) && argument[0] == '-'))
+  if((lstat(file.c_str(), &stt)) == -1 && ((util.is_set(flag, COM_LONG) ||
+          util.is_set(flag, COM_MLSD)) && argument[0] == '-'))
   {
     class StringTokenizer *token = new StringTokenizer(argument, " ", false);
     token->nextToken();
     argument = token->restTokens();
     delete token;
     file = parsedir(user, argument);
-    stat_err = lstat(file.c_str(), &stt);
+    lstat(file.c_str(), &stt);
   }
 
   if(!S_ISDIR(stt.st_mode) && util.is_set(flag, COM_MLSD))
   {
-    ftp_send(user, "501 Argument to MLSD has to be a directory.");
+    *user << "501 Argument to MLSD has to be a directory.\r\n";
     return false;
   }
 
   class Data *data = new Data(user);
 
-  if(!data->isOpen())
+  if(!data->settings(DATA_OPEN))
     failure = "425 Can't open data connection.";
   else
   {
-    string message;
-    size_t write_size = READ_SIZE;
+    *user << "150 Opening ";
+#ifdef USE_TLS
+    if(data->settings(TLS_PROT_D))
+    {
+      *user << "PROTECTED ASCII mode data connection for file list.\r\n";
+      if(!data->engage_tls())
+        failure =
+          "451 Failed to negotiate TLS as was asked. Closing data connection.";
+    }
+    else
+#endif // USE_TLS
+      *user << " ASCII mode data connection for file list.\r\n";
     if(S_ISDIR(stt.st_mode))
     {
       struct dirent dirstr, *dirptr;
@@ -430,115 +447,83 @@ bool Commands::list(User *user, string a
 
       closedir(dirp);
 
-      sort(dirlist.begin(), dirlist.end()); // sorting the directory so we output first things first
-      for(vector<string>::iterator dir_it = dirlist.begin(); dir_it != dirlist.end(); dir_it++)
+      // sorting the directory so we output first things first
+      sort(dirlist.begin(), dirlist.end());
+      for(vector<string>::iterator dir_it = dirlist.begin();
+          dir_it != dirlist.end(); dir_it++)
       {
         if(util.is_set(flag, COM_LONG))
-          message += list_file(file + "/" + *dir_it);
+          *data << list_file(file + "/" + *dir_it);
         else if(util.is_set(flag, COM_MLSD))
-          message += mlsx(user, file + "/" + *dir_it);
+          *data << mlsx(user, file + "/" + *dir_it);
         else
-          message += *dir_it; // short list.
+          *data << *dir_it; // short list.
 
-        message += "\r\n"; // and newline.
+        *data << "\r\n";
+        if(data->settings(FAILURE))
+          break;
       }
     }
     else
     {
       if(util.is_set(flag, COM_LONG))
-        message += list_file(file);
-      else
-        message += argument;
-      message += "\r\n";
+        *data << list_file(file);
+      else // NLST
+        *data << argument;
+      *data << "\r\n";
     }
-    sem_wait(&data->data_lock);
-#ifdef USE_TLS
-    if(user->settings.test(TLS_PROT_D))
-    {
-      ftp_send(user, "150 Opening PROTECTED ASCII mode data connection for file list.");
-      if(gnutls_handshake(data->data_session) < 0) // handshake failed
-        failure =  "451 Failed to negotiate TLS as was asked. Closing data connection.";
-      else
-        write_size = gnutls_record_get_max_size(data->data_session);
-    }
-    else
-#endif
-      ftp_send(user, "150 Opening ASCII mode data connection for file list.");
-
-
-    size_t written = 0;
-    struct timeval tv = { 1,0 };
-    fd_set wfds;
-    FD_ZERO(&wfds);
-    FD_SET(data->data_id, &wfds);
-
-    if(!select(data->data_id + 1, NULL, &wfds, NULL, &tv))
-      failure = "425 Data connection lost.";
-
-    while(written < message.size() && !failure.size())
-    {
-      string writing;
-
-      writing.assign(message, written, write_size);
-#ifdef USE_TLS
-      if(user->settings.test(TLS_PROT_D))
-      {
-        if(failure.size() == 0)
-          written += gnutls_record_send(data->data_session, static_cast<const void*>(writing.c_str()), writing.size());
-      } else
-#endif // USE_TLS
-        written += write(data->data_id, static_cast<const void*>(writing.c_str()), writing.size());
-    }
-    close(data->data_id);
-    sem_post(&data->data_lock);
-    sem_wait(&user->user_lock);
-    user->total_transfered += written;
-    sem_post(&user->user_lock);
+    if(data->settings(FAILURE))
+      failure = "426 LIST transfer failed.";
   }
   if(failure.size() > 0)
-    ftp_send(user, failure);
+    *user << failure << "\r\n";
   else
-    ftp_send(user, "226 Transfer complete.");
+    *user << "226 Transfer complete.\r\n";
   delete data;
-  return(true);
+  return(data->settings(FAILURE));
 }
 
 string Commands::list_file(string file_name)
 {
-  char size[20], nlink[6], time_string[25], pwdbuf[PWBUF_SIZE], grpbuf[PWBUF_SIZE];
-  string user_name, group_name;
+  char size[20], nlink[6], pwdbuf[PWBUF_SIZE], grpbuf[PWBUF_SIZE];
+  string user_name, group_name, time_string;
   struct stat file_stat;
   struct passwd pwd, *pwd_ptr;
   struct group grp, *grp_ptr;
-  struct tm file_time;
 
   lstat(file_name.c_str(), &file_stat);
 
-  snprintf(nlink, 5, "%3d ", static_cast<int>(file_stat.st_nlink)); // number of hard links
+  // number of hard links
+  snprintf(nlink, 5, "%3d ", static_cast<int>(file_stat.st_nlink));
 
-  if((getpwuid_r(file_stat.st_uid, &pwd, pwdbuf, sizeof(pwdbuf), &pwd_ptr)) == 0)
+  if((getpwuid_r(file_stat.st_uid, &pwd, pwdbuf, sizeof(pwdbuf),
+          &pwd_ptr)) == 0)
     user_name = pwd.pw_name;
   else
     user_name = util.itos(file_stat.st_uid);
 
-  if((getgrgid_r(file_stat.st_gid, &grp, grpbuf, sizeof(grpbuf), &grp_ptr)) == 0)
+  if((getgrgid_r(file_stat.st_gid, &grp, grpbuf, sizeof(grpbuf),
+          &grp_ptr)) == 0)
     group_name = grp.gr_name;
   else
     group_name = util.itos(file_stat.st_gid);
 
   snprintf(size, 19, "%9d ", static_cast<int>(file_stat.st_size)); // filesize
 
-  gmtime_r(&file_stat.st_mtime, &file_time);
   // modification time, either in new ls format, or old..
 #ifdef USE_NEWLS
-  strftime(time_string, 24, "%Y-%m-%d %H:%M ", &file_time);
+  string time_format = "%Y-%m-%d %H:%M ";
 #else
-  if((time(NULL) - file_stat.st_mtime) > (60 * 60 * 24 * 365)) // is the file over a year old?
-    strftime(time_string, 24, "%b %e  %Y ", &file_time);
+  string time_format;
+  // is the file over a year old?
+  if((time(NULL) - file_stat.st_mtime) > (60 * 60 * 24 * 365))
+    time_format = "%b %e  %Y ";
   else // if it's not, we display the time it was created as well.
-    strftime(time_string, 24, "%b %e %H:%M ", &file_time);
+    time_format = "%b %e %H:%M ";
 #endif // USE_NEWLS
 
+  util.time_string(time_string, time_format, 25, file_stat.st_mtime);
+
   string message = (util.parse_perms_ls(file_stat.st_mode) + ' ')
     + nlink + user_name + '\t' + group_name + '\t' + size + time_string
     + basename(file_name.c_str()); // parsing everything on one line is neater.
@@ -567,19 +552,19 @@ string Commands::mlsx(User *user, string
   lstat(file_name.c_str(), &stt);
 
   // type.
-  if(user->settings.test(FACT_TYPE))
+  if(user->settings(FACT_TYPE))
   {
     string type;
     if(S_ISREG(stt.st_mode))
       type = "file";
     else if(S_ISDIR(stt.st_mode))
     {
-      if(file_name == user->current_dir)
+      if(file_name == user->current_dir())
       {
         type = "cdir";
         file_name += "/.";
       }
-      else if(file_name == parsedir(user, user->current_dir + "/.."))
+      else if(file_name == parsedir(user, user->current_dir() + "/.."))
         type = "pdir";
       else
         type = "dir";
@@ -598,17 +583,23 @@ string Commands::mlsx(User *user, string
     message =  "Type=" + type + ";";
   }
 
-  if(user->settings.test(FACT_SIZE))
+  if(user->settings(FACT_SIZE))
     message += "Size=" + util.itos(stt.st_size) + ";";
-  if(user->settings.test(FACT_MODIFY))
-    message += "Modify=" + mod_time(stt) + ";"; // mod time...
-  if(user->settings.test(FACT_UNIQUE))
-    message += "Unique=" + util.itos(stt.st_dev) + "g" + util.itos(stt.st_ino) + ";";
-  if(user->settings.test(FACT_PERM))
+  if(user->settings(FACT_MODIFY))
+  {
+    string tmp_time;
+    util.time_string(tmp_time, "Modify=%Y%m%d%H%M%S;", 23, stt.st_mtime);
+    message += tmp_time;
+  }
+  if(user->settings(FACT_UNIQUE))
+    message += "Unique=" + util.itos(stt.st_dev) + "g" +
+      util.itos(stt.st_ino) + ";";
+  if(user->settings(FACT_PERM))
   {
     bool owner = false, group = false;
 
-    if(getpwnam_r(user->user_name.c_str(), &pwd, pwdbuf, sizeof(pwdbuf), &pwd_ptr))
+    if(getpwnam_r(user->user_name().c_str(), &pwd, pwdbuf, sizeof(pwdbuf),
+          &pwd_ptr))
     {
       if(pwd.pw_uid == stt.st_uid)
         owner = true;
@@ -620,7 +611,7 @@ string Commands::mlsx(User *user, string
     {
       if(getgrgid_r(stt.st_gid, &grp, grpbuf, sizeof(grpbuf), &grp_ptr))
         for(int i = 0; grp.gr_mem[i] != NULL; i++)
-          if(user->user_name == grp.gr_mem[i])
+          if(user->user_name() == grp.gr_mem[i])
             group = true;
     }
 
@@ -629,56 +620,55 @@ string Commands::mlsx(User *user, string
     {
       if(S_ISDIR(stt.st_mode))
       {
-        if(util.test(stt.st_mode, S_IRUSR)) message += "l";
-        if(util.test(stt.st_mode, S_IWUSR)) message += "cmp";
-        if(util.test(stt.st_mode, S_IXUSR)) message += "e";
+        if(util.is_set(stt.st_mode, S_IRUSR)) message += "l";
+        if(util.is_set(stt.st_mode, S_IWUSR)) message += "cmp";
+        if(util.is_set(stt.st_mode, S_IXUSR)) message += "e";
       }
-      if(util.test(stt.st_mode, S_IRUSR)) message += "r";
-      if(util.test(stt.st_mode, S_IWUSR)) message += "adfw";
+      if(util.is_set(stt.st_mode, S_IRUSR)) message += "r";
+      if(util.is_set(stt.st_mode, S_IWUSR)) message += "adfw";
     }
     else if(group)
     {
       if(S_ISDIR(stt.st_mode))
       {
-        if(util.test(stt.st_mode, S_IRGRP)) message += "l";
-        if(util.test(stt.st_mode, S_IWGRP)) message += "cmp";
-        if(util.test(stt.st_mode, S_IXGRP)) message += "e";
+        if(util.is_set(stt.st_mode, S_IRGRP)) message += "l";
+        if(util.is_set(stt.st_mode, S_IWGRP)) message += "cmp";
+        if(util.is_set(stt.st_mode, S_IXGRP)) message += "e";
       }
-      if(util.test(stt.st_mode, S_IRGRP)) message += "r";
-      if(util.test(stt.st_mode, S_IWGRP)) message += "adfw";
+      if(util.is_set(stt.st_mode, S_IRGRP)) message += "r";
+      if(util.is_set(stt.st_mode, S_IWGRP)) message += "adfw";
     }
     else
     {
       if(S_ISDIR(stt.st_mode))
       {
-        if(util.test(stt.st_mode, S_IROTH)) message += "l";
-        if(util.test(stt.st_mode, S_IWOTH)) message += "cmp";
-        if(util.test(stt.st_mode, S_IXOTH)) message += "e";
+        if(util.is_set(stt.st_mode, S_IROTH)) message += "l";
+        if(util.is_set(stt.st_mode, S_IWOTH)) message += "cmp";
+        if(util.is_set(stt.st_mode, S_IXOTH)) message += "e";
       }
-      if(util.test(stt.st_mode, S_IROTH)) message += "r";
-      if(util.test(stt.st_mode, S_IWOTH)) message += "adfw";
+      if(util.is_set(stt.st_mode, S_IROTH)) message += "r";
+      if(util.is_set(stt.st_mode, S_IWOTH)) message += "adfw";
     }
     message += ";";
   }
-  if(user->settings.test(FACT_U_MODE))
+  if(user->settings(FACT_U_MODE))
     message += "Unix.mode=" + util.parse_perms_num(stt.st_mode) + ";";
-  if(user->settings.test(FACT_U_UID))
+  if(user->settings(FACT_U_UID))
     message += "Unix.uid=" + util.itos(stt.st_uid) + ";";
-  if(user->settings.test(FACT_U_GID))
+  if(user->settings(FACT_U_GID))
     message += "Unix.gid=" + util.itos(stt.st_gid) + ";";
-  if(user->settings.test(FACT_U_LINK))
+  if(user->settings(FACT_U_LINK))
     message += "Unix.link=" + util.itos(stt.st_nlink) + ";";
-  if(user->root_dir.size() > 1)
-    file_name.erase(0, user->root_dir.size());
+  if(user->root_dir().size() > 1)
+    file_name.erase(0, user->root_dir().size());
   message += " " + file_name;
 
   return(message);
 }
 
-
-bool Commands::mkd(User *user, string dir, unsigned int flag)
+BABY_COM(Commands::mkd)
 {
-  string message, new_dir = parsedir(user, dir);
+  string message, new_dir = parsedir(user, argument);
 
   if(mkdir(new_dir.c_str(), 0755))
   {
@@ -688,20 +678,20 @@ bool Commands::mkd(User *user, string di
     else if(errno == EACCES)
       message += "Write access denied.";
     else if(errno == (ENOTDIR || ENOENT))
-      message += "Faulty pathname, directory not created.\r\n";
+      message += "Faulty pathname, directory not created.";
     else
       message += "Directory not created.";
   }
   else
-    message = "257 \"" + dir + "\" created.\r\n";
+    message = "257 \"" + argument + "\" created.";
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::rmd(User *user, string dir, unsigned int flag)
+BABY_COM(Commands::rmd)
 {
-  string message, new_dir = parsedir(user, dir);
+  string message, new_dir = parsedir(user, argument);
 
   if(rmdir(new_dir.c_str()))
   {
@@ -714,15 +704,15 @@ bool Commands::rmd(User *user, string di
       message += "Directory not removed.";
   }
   else
-    message = "250 \"" + dir + "\" removed.";
+    message = "250 \"" + argument + "\" removed.";
 
-  ftp_send(user, message);
+  *user << message << "\r\n";
   return(true);
 }
 
-bool Commands::dele(User *user, string file, unsigned int flag)
+BABY_COM(Commands::dele)
 {
-  string message, new_file = parsedir(user, file);
+  string message, new_file = parsedir(user, argument);
 
   if(unlink(new_file.c_str()))
   {
